<template>
  <q-select
    outlined
    bg-color="white"
    dropdown-icon="false"
    v-model="location"
    use-input
    hide-selected
    fill-input
    input-debounce="0"
    label="Cari Lokasi"
    :options="options"
    @filter="filterFnAutoselect"

    @input="updateState"
    @clear="hapusSemua"
    @remove="hapusSemua"
  >
    <template v-slot:no-option>
      <q-item>
        <q-item-section class="text-grey">
          Kota Tidak Ditemukan
        </q-item-section>
      </q-item>
    </template>

    <template v-slot:append>
      <q-btn style="background-color: orange; height: 56px; width: 56px; margin-right: -38px"  dense flat icon="search" />
    </template>
  </q-select>
</template>

<script>
export default {
  name: 'LocationSelect',
  data () {
    return {
      options: ["Semua Kota"],
      location: localStorage.getItem("kota") || "Semua Kota"
    }
  },

  methods: {
    async filterFnAutoselect(val, update, abort) {
      this.options = ["Semua Kota"];
      if (val !== "") {
        await this.$axios.get("/api/location/" + val)
          .then(sukses => {
            let data = sukses.data;
            this.options = ["Semua Kota"];
            for (let i = 0; i < data.length; i++ ) {
              this.options.push(data[i].name)
            }
          })

        update(
          () => {
            if (val === '') {
              this.options = ["Semua Kota"]
            }
            else {
              const needle = val.toLowerCase()
              this.options = this.options.filter(v => v.toLowerCase().indexOf(needle) > -1)
            }
          },

          ref => {
            if (val !== '' && ref.options.length > 0 && ref.optionIndex === -1) {
              ref.moveOptionSelection(1, true) // focus the first selectable option and do not update the input-value
              ref.toggleOption(ref.options[ref.optionIndex], true) // toggle the focused option
            }
          }
        )
      } else {
        this.location = "Semua Kota";
        // this.options = ["Semua Kota"];
        this.$store.dispatch("product/getProductHome", {
          flag: "jasa",
          location: this.location
        })
        this.$store.commit("lokasi/setLocation", this.location);
      }

      abort(
        () => {
          this.options = ["Semua Kota"];
          this.location = "Semua Kota";
        }
      )
    },

    hapusSemua() {
      // alert("clear");
      // this.options = ["Semua Kota"];
      // this.location = "Semua Kota";
      // this.$store.dispatch("product/getProductHome", {
      //   flag: "jasa",
      //   location: this.location
      // })
      // this.$store.commit("lokasi/setLocation", this.location);
    },

    abortFilterFn() {
      // alert("clear");
    },

    updateState() {
      // localStorage.setItem("kota", this.location);
      this.$store.dispatch("product/getProductHome", {
        flag: "jasa",
        location: this.location
      })
      this.$store.commit("lokasi/setLocation", this.location);
    }
  }
}
</script>
